import App from './App'
import Vue from 'vue'

// 引入 uni-ui 组件
import { uniBadge, uniTable, uniTr, uniTh, uniTd } from '@dcloudio/uni-ui'
Vue.component('uni-badge', uniBadge)
Vue.component('uni-table', uniTable)
Vue.component('uni-tr', uniTr)
Vue.component('uni-th', uniTh)
Vue.component('uni-td', uniTd)

Vue.config.productionTip = false
App.mpType = 'app'

// #ifndef VUE3

try {
  function isPromise(obj) {
    return (
      !!obj &&
      (typeof obj === "object" || typeof obj === "function") &&
      typeof obj.then === "function"
    );
  }

  // 统一 vue2 API Promise 化返回格式与 vue3 保持一致
  uni.addInterceptor({
    returnValue(res) {
      if (!isPromise(res)) {
        return res;
      }
      return new Promise((resolve, reject) => {
        res.then((res) => {
          if (res[0]) {
            reject(res[0]);
          } else {
            resolve(res[1]);
          }
        });
      });
    },
  });
} catch (error) { }

const app = new Vue({
  ...App
})
app.$mount()
// #endif

// #ifdef VUE3
import { createSSRApp } from 'vue'
export function createApp() {
  const app = createSSRApp(App)
  return {
    app
  }
}
// #endif